% STATI DI EQUILIBRIO
% simulazione del sistema nonlineare 
% tutti gli stati iniziali a 0.5
% la simulazione e' lasciata andare per tempi lunghi cosi' da raggiungere
% gli stati di equilibrio
[t,x]=ode15s('cola4',[0 20000],0.5*ones(1,82)'); 
lengthx=size(x); Xinit = x(lengthx(1),:)';
plot(t,x)
plot(Xinit(1:41))
% RISPOSTA A GRADINO DEL SISTEMA NONLINEARE
% Alimento il sistema nonlineare con i valori nominali precedenti 
% in cui l'ingresso F viene aumentato da 1 a 1.01
[t,x]=ode15s('cola4_F1',[0 500],Xinit); 
t0 = t; M1=x(:,42); xB = x(:,1); yD = x(:,41); % Save the data for plotting
plot(t0,M1)
axis([0 5, 0.45 0.55])
plot(t0,xB)
plot(t0,yD)
% RISPOSTA A GRADINO DEL SISTEMA NONLINEARE
% Alimento il sistema nonlineare con i valori nominali precedenti 
% qui il sistema nonlineare e' nalla cosi' detta configurazione controllata
% LV in cui il MD e MB e' controllato con D e B
% in cui l'ingresso F viene aumentato da 1 a 1.01
[t,x]=ode15s('cola_lv_F1',[0 500],Xinit); 
tlv=t; M1lv=x(:,42); xBlv = x(:,1); yDlv = x(:,41); %save data for plot
plot(tlv,M1lv)
hold on
plot(t0,M1)
axis([0 20, 0.5 0.51])
plot(tlv,xBlv)
hold on
plot(t0,xB)
plot(tlv,yDlv)
hold on
plot(t0,yD)
% LINEARIZZAZIONE
% A,B,C,D sono le matrici del sistema linearizzato con 82 stati
% ingressi [L V D B F zF] e uscite [yD xB MD MB] 
% determiniamo autovalori (= poli) ha 2 poli in 0 (doppio integratore)
% e uno dominante in -0.0052= costante di tempo = 193 min
Ls=2.706; Vs=3.206; Ds=0.5; Bs=0.5; Fs=1.0; zFs=0.5;
[A,B,C,D]=cola_linearize('cola4_lin',Xinit',[Ls Vs Ds Bs Fs zFs]);
eig(A)
% LINEARIZZAZIONE DEL SISTEMA CONTROLLATO
% In questo caso si linearizza il sistema controllato in configurazione LV
% A,B,C,D sono le matrici del sistema linearizzato con 82 stati
% ingressi [L V F zF] e uscite [yD xB] 
% determiniamo autovalori (= poli) ha 2 poli in 0 (doppio integratore)
% e uno dominante in -0.0052= costante di tempo = 193 min
% matrice di traferimento
Ls=2.706; Vs=3.206; Ds=0.5; Bs=0.5; Fs=1.0; zFs=0.5;
[A,B,C,D]=cola_linearize('cola_lv_lin',Xinit',[Ls Vs Ds Bs Fs zFs]);
% SCALATURA
% prima rifaccio la linearizzazione del sistema non controllato
% ingressi [LT VB D B] disturbi [F zF] uscite [yD xB MD MB]
Ls=2.706; Vs=3.206; Ds=0.5; Bs=0.5; Fs=1.0; zFs=0.5;
[A,B,C,D]=cola_linearize('cola4_lin',Xinit',[Ls Vs Ds Bs Fs zFs]);
Du = diag([1 1 1 1]);                  % max inputs (scalings)
Dd = diag([ .2 .1]);                   % max disturbances (scalings)
De = diag([0.01 0.01 1 1]);            % max output errors (scalings)
Dud=diag([1 1 1 1 .2 .1]);
As=A;
Bs=B*Dud;
Cs=inv(De)*C;
Ds=inv(De)*D*Dud;
% MODELLO DI ORDINE RIDOTTO
% Attraverso il tool sdecomp, sysbal e hankmr  
% si riduce il sistema nonlineare non controllato da 82 a 8 stati
% ingressi [L V D B F zF] e uscite [yD xB MD MB] 
% CON scalatura su
% disturdi e uscite F/20%F=F/0.2 zF/20%zF=zF/0.1 xB/0.01 yD/0.01
Ar=G4_8(1:8,1:8);
Br=G4_8(1:8,9:14);
Cr=G4_8(9:12,1:8);
Dr=G4_8(9:12,9:14);
% MODELLO DI ORDINE RIDOTTO
% Attraverso il tool sdecomp, sysbal e hankmr  
% si riduce il sistema nonlineare non controllato da 82 a 8 stati
% ingressi [L V D B F zF] e uscite [yD xB MD MB] 
% SENZA scalatura 
Aur=G4u_8(1:8,1:8);
Bur=G4u_8(1:8,9:14);
Cur=G4u_8(9:12,1:8);
Dur=G4u_8(9:12,9:14);
s=tf('s');
Gur=minreal((Cur*((s*eye(size(Aur)))-Aur)^-1)*Bur);
% MODELLO DI ORDINE RIDOTTO
% Attraverso un metodo non spiegato si riduce il sistema nonlineare 
% controllato in configurazione LV linearizzato da 82 a 5 stati
% 2 ingressi (L,V) 2 disturbi  (F,zF) e 2 uscite (yd,xb)
% pare (vedi pag 445 di Skogestad) che sia stata fatta una scalatura su
% disturdi e uscite F/20%F=F/0.2 zF/20%zF=zF/0.1 xB/0.01 yD/0.01
% pag 495 Skogestad
A = [ -5.131e-3 0 0 0 0; 0 -7.366e-2 0 0 0; 0 0 -1.829e-1 0 0;
       0 0 0 -4.620e-1  9.895e-1; 0 0 0 -9.895e-1 -4.620e-1]
B = [-.629 .624; .055 -0.172; 0.030 -0.108; 
      -0.186 -0.139; -1.23 -0.056]
C= [-0.7223 -0.5170 0.3386 -0.1633e-1 0.1121;
    -0.8913 0.4728 0.9876 0.8425 0.2186]
D = [ 0 0; 0 0]
Bd = [-0.062 -0.067; 0.131 0.040; 0.022 -0.106; 
     -0.188 0.027; -0.045 0.014]
 s=tf('s');
 G=minreal((C*((s*eye(size(A)))-A)^-1)*B);
 zero(G)
 Gd=minreal((C*((s*eye(size(A)))-A)^-1)*Bd);
 zero(Gd)
